using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using JUNKBOX.IO;

namespace captureTest
{
    public partial class Form1 : Form
    {
        CaptureDevice camera;
        public Form1()
        {
            InitializeComponent();

            // ׂẴLv`foCX擾
            VideoCapture capture = new VideoCapture();
            List<CaptureDevice> devices = capture.Devices;

            if (devices != null)
            {
                // 0Ԗڂ̃foCX擾
                camera = devices[0];
                this.toolStripStatusLabel1.Text = camera.Name;

                // 0Ԗڂ̃foCX 640x480 pixel  Bitmap o͂悤ɏ
                camera.Activate(this.previewPanel, 640, 480);
            }
            else
            {
                this.toolStripStatusLabel1.Text = "Lv`foCX܂ł";
                this.button1.Enabled = false;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Î~Lv`
            Bitmap bmp = this.camera.Capture();

            // Bitmap  byte[] ɍϊ
            byte[] rgbValues = VideoCapture.BitmapToByteArray(bmp);

            // w肵邳ȏ̉f𔒂ɕύX
            for (int p = 0; p < rgbValues.Length; p += 4)
            {
                int c = (rgbValues[p]+rgbValues[p+1]+rgbValues[p+2])/3;
                if (c > 128)
                {
                    rgbValues[p] = 255;
                    rgbValues[p+1] = 255;
                    rgbValues[p+2] = 255;
                }
            }

            // byte[]  Bitmap ɍϊ
            this.pictureBox1.Image = VideoCapture.ByteArrayToBitmap(rgbValues,bmp);
        }

        private void previewPanel_Resize(object sender, EventArgs e)
        {
            if (this.camera != null)
            {
              //  this.camera.ResizePreviewWindow();
            }
        }

    }
}